diff -ruN versions/nakedmudv3.6/src/scripts/pyroom.h src/scripts/pyroom.h
--- versions/nakedmudv3.6/src/scripts/pyroom.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyroom.h	2008-12-01 03:19:11.000000000 -0500
@@ -12,6 +12,9 @@
 //
 //*****************************************************************************
 
+// used by pymudsys. Do not touch!
+PyTypeObject PyRoom_Type;
+
 // initialize rooms for use. This must be called AFTER all other modules
 // have added in new get/setters and methods to pyroom
 PyMODINIT_FUNC init_PyRoom(void);
diff -ruN versions/nakedmudv3.6/src/scripts/pysocket.h src/scripts/pysocket.h
--- versions/nakedmudv3.6/src/scripts/pysocket.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pysocket.h	2008-12-01 03:17:54.000000000 -0500
@@ -12,6 +12,9 @@
 //
 //*****************************************************************************
 
+// used by pymudsys. Do not touch!
+PyTypeObject PySocket_Type;
+
 // initialize sockets for use. This must be called AFTER all other modules
 // have added in new get/setters and methods to pyroom
 PyMODINIT_FUNC   init_PySocket(void);
diff -ruN versions/nakedmudv3.6/src/scripts/scripts.c src/scripts/scripts.c
--- versions/nakedmudv3.6/src/scripts/scripts.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/scripts.c	2008-12-03 04:23:11.000000000 -0500
@@ -40,6 +40,7 @@
 #include "pystorage.h"
 #include "pyauxiliary.h"
 #include "trighooks.h"
+#include "pyolc.h"
 
 // online editor stuff
 #include "../editor/editor.h"
@@ -52,6 +53,13 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../olc2/olc.h"
+
+
+
+//*****************************************************************************
 // auxiliary data
 //*****************************************************************************
 typedef struct {
@@ -349,6 +357,7 @@
   init_PyObj();
   init_PyMud();
   init_PyHooks();
+  init_PyOLC();
 
   // initialize all of our modules written in Python
   init_pyplugs();
@@ -402,6 +411,7 @@
   if(sys != NULL) {
     PyObject *exit = PyDict_GetItemString(PyModule_GetDict(sys), "exit");
     if(exit != NULL) PyDict_SetItemString(dict, "exit", exit);
+    if(exit != NULL) PyDict_SetItemString(dict, "end_script", exit);
     Py_DECREF(sys);
   }
   
@@ -493,12 +503,8 @@
     run_code(retval, dict, locale);
   
   // did we end up with an error?
-  if(retval == NULL || !last_script_ok()) {
-    char *tb = getPythonTraceback();
-    log_string("Script terminated with an error:\r\n%s\r\n"
-	       "\r\nTraceback is:\r\n%s\r\n", script, tb);
-    free(tb);
-  }
+  if(retval == NULL || !last_script_ok())
+    log_pyerr("Script terminated with an error:\r\n%s", script);
 
   // return our code object
   return retval;
@@ -516,12 +522,8 @@
   PyObject *retval = PyRun_String(statement, Py_eval_input, dict, dict);
 
   // did we encounter an error?
-  if(retval == NULL) {
-    char *tb = getPythonTraceback();
-    log_string("eval_script terminated with an error:\r\n%s\r\n"
-	       "\r\nTraceback is:\r\n%s\r\n", statement, tb);
-    free(tb);
-  }
+  if(retval == NULL)
+    log_pyerr("eval_script terminated with an error:\r\n%s", statement);
 
   free(listPop(locale_stack));
   return retval;
diff -ruN versions/nakedmudv3.6/src/scripts/trigedit.c src/scripts/trigedit.c
--- versions/nakedmudv3.6/src/scripts/trigedit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/trigedit.c	2008-11-24 17:47:28.000000000 -0500
@@ -100,7 +100,7 @@
   { "get",            "obj, room" },
   { "give",           "obj, mob"  },
   { "receive",        "mob"       },
-  { "wear",           "mob"       },
+  { "wear",           "obj, mob"  },
   { "remove",         "obj, mob"  },
   { "reset",          "room"      },
   { "combat",         "mob"       },
diff -ruN versions/nakedmudv3.6/src/scripts/triggers.c src/scripts/triggers.c
--- versions/nakedmudv3.6/src/scripts/triggers.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/triggers.c	2008-12-01 22:18:18.000000000 -0500
@@ -131,12 +131,8 @@
   else {
     run_code(trigger->pycode, dict, get_key_locale(triggerGetKey(trigger)));
     
-    if(!last_script_ok()) {
-      char *tb = getPythonTraceback();
-      log_string("Trigger %s terminated with an error:\r\n%s\r\n"
-		 "\r\nTraceback is:\r\n%s\r\n", 
-		 trigger->key, bufferString(trigger->code), tb);
-      free(tb);
-    }
+    if(!last_script_ok())
+      log_pyerr("Trigger %s terminated with an error:\r\n%s",
+		trigger->key, bufferString(trigger->code));
   }
 }
diff -ruN versions/nakedmudv3.6/src/socket.c src/socket.c
--- versions/nakedmudv3.6/src/socket.c	2008-05-31 00:17:59.000000000 -0400
+++ src/socket.c	2008-12-01 22:32:14.000000000 -0500
@@ -402,7 +402,7 @@
     static char buf[MAX_BUFFER];
     va_list args;
     va_start(args, format);
-    vsprintf(buf, format, args);
+    vsnprintf(buf, MAX_BUFFER, format, args);
     va_end(args);
     text_to_buffer(dsock, buf);
   }
@@ -790,13 +790,8 @@
 	PyObject *retval  = PyEval_CallObject(pair->handler, arglist);
 
 	// check for an error:
-	if(retval == NULL) {
-	  char *tb = getPythonTraceback();
-	  if(tb != NULL) {
-	    log_string("Error with a python input handler:\r\n%s\r\n", tb);
-	    free(tb);
-	  }
-	}
+	if(retval == NULL)
+	  log_pyerr("Error with a Python input handler");
 	
 	// garbage collection
 	Py_XDECREF(retval);
@@ -1094,13 +1089,8 @@
     PyObject *arglist = Py_BuildValue("(O)", socketGetPyFormBorrowed(sock));
     PyObject *retval  = PyEval_CallObject(pair->prompt, arglist);
     // check for an error:
-    if(retval == NULL) {
-      char *tb = getPythonTraceback();
-      if(tb != NULL) {
-	log_string("Error with a python prompt:\r\n%s\r\n", tb);
-	free(tb);
-      }
-    }
+    if(retval == NULL)
+      log_pyerr("Error with a Python prompt");
     
     // garbage collection
     Py_XDECREF(retval);
diff -ruN versions/nakedmudv3.6/src/utils.c src/utils.c
--- versions/nakedmudv3.6/src/utils.c	2008-05-31 00:17:59.000000000 -0400
+++ src/utils.c	2008-12-03 02:20:13.000000000 -0500
@@ -1309,6 +1309,33 @@
   }
 }
 
+const char *get_shortkey(const char *key, const char *to) {
+  // are we missing a locale?
+  int pos = next_letter_in(key, '@');
+  if(pos < 0)
+    return key;
+
+  // if 'to' doesn't exist, make sure we return the full thing back.
+  // Only relevant for attaching triggers to characters instead of mobiles
+  if(!*to)
+    return key;
+
+  // is 'to' missing a locale?
+  pos = next_letter_in(to, '@');
+  if(pos < 0)
+    return get_key_name(key);
+
+  // two keys, both with a name and a locale. See if our locales match up
+  static char name[SMALL_BUFFER];
+  static char locale[SMALL_BUFFER];
+  parse_worldkey(key, name, locale);
+  if(!strcmp(locale, get_key_locale(to)))
+    return name;
+
+  // different locales, return the full key
+  return key;
+}
+
 bool cmd_matches(const char *pattern, const char *cmd) {
   int len = next_letter_in(pattern, '*');
   // we have to match exactly
diff -ruN versions/nakedmudv3.6/src/utils.h src/utils.h
--- versions/nakedmudv3.6/src/utils.h	2008-05-31 00:17:59.000000000 -0400
+++ src/utils.h	2008-12-03 01:25:06.000000000 -0500
@@ -197,6 +197,12 @@
 const char *get_fullkey_relative(const char *key, const char *locale);
 
 //
+// Returns the shortest version of key, relative to the other key, 'to'.
+// If they have separate locales, return the fullkey of key. If they have the
+// same locale, just return the first portion of the key
+const char *get_shortkey(const char *key, const char *to);
+
+//
 // Returns whether or not the command matches the pattern. Patterns are just
 // like commands, except they can be terminated with *'s to signify that
 // "anything can follow at this point". Example matches might include:
diff -ruN versions/nakedmudv3.6/src/world.c src/world.c
--- versions/nakedmudv3.6/src/world.c	2008-05-31 00:17:59.000000000 -0400
+++ src/world.c	2008-12-03 16:29:39.000000000 -0500
@@ -28,10 +28,11 @@
 #define HUGE_WORLD      250000
 
 typedef struct {
-  void      *(* read_func)(STORAGE_SET *);
-  STORAGE_SET     *(* store_func)(void *);
-  void            (* delete_func)(void *);
-  void (* key_func)(void *, const char *);
+  void   *read_func;
+  void  *store_func;
+  void *delete_func;
+  void    *key_func;
+  bool    forgetful;
 } WORLD_TYPE_DATA;
 
 struct world_data {
@@ -42,12 +43,13 @@
 };
 
 WORLD_TYPE_DATA *newWorldTypeData(void *reader, void *storer, void *deleter,
-				  void *keysetter) {
+				  void *keysetter, bool forgetful) {
   WORLD_TYPE_DATA *data = malloc(sizeof(WORLD_TYPE_DATA));
   data->read_func       = reader;
   data->store_func      = storer;
   data->delete_func     = deleter;
   data->key_func        = keysetter;
+  data->forgetful       = forgetful;
   return data;
 }
 
@@ -304,7 +306,7 @@
   // add the new type to each of our zones, too
   if(!hashIn(world->type_table, type)) {
     hashPut(world->type_table, type, 
-	    newWorldTypeData(reader, storer, deleter, zonesetter));
+	    newWorldTypeData(reader, storer, deleter, zonesetter, FALSE));
     HASH_ITERATOR *zone_i = newHashIterator(world->zones);
     const char       *key = NULL;
     ZONE_DATA       *zone = NULL;
@@ -314,6 +316,21 @@
   }
 }
 
+void worldAddForgetfulType(WORLD_DATA *world, const char *type, void *reader,
+			   void *storer, void *deleter, void *zonesetter) {
+  // add the new type to each of our zones, too
+  if(!hashIn(world->type_table, type)) {
+    hashPut(world->type_table, type, 
+	    newWorldTypeData(reader, storer, deleter, zonesetter, TRUE));
+    HASH_ITERATOR *zone_i = newHashIterator(world->zones);
+    const char       *key = NULL;
+    ZONE_DATA       *zone = NULL;
+    ITERATE_HASH(key, zone, zone_i)
+      zoneAddForgetfulType(zone, type, reader, storer, deleter, zonesetter);
+    deleteHashIterator(zone_i);
+  }
+}
+
 ZONE_DATA *worldGetZone(WORLD_DATA *world, const char *key) {
   return hashGet(world->zones, key);
 }
diff -ruN versions/nakedmudv3.6/src/world.h src/world.h
--- versions/nakedmudv3.6/src/world.h	2008-05-31 00:17:59.000000000 -0400
+++ src/world.h	2008-12-03 16:29:27.000000000 -0500
@@ -42,6 +42,15 @@
 void     worldAddType(WORLD_DATA *world, const char *type, void *reader,
 		      void *storer, void *deleter, void *typesetter);
 
+//
+// some types can 'forget' what they are. This is a fudge so Python can add
+// types to the world, and we can do a lookup on the functions that need to
+// be called, without having to explicitly deal with Python in world.c.
+// Forgetful functions are exactly the same as normal functions, except they
+// take an additional initial argument, which is a const string of their type
+void worldAddForgetfulType(WORLD_DATA *world, const char *type, void *reader,
+			   void *storer, void *deleter, void *typesetter);
+
 ZONE_DATA *worldRemoveZone(WORLD_DATA *world, const char *key);
 ROOM_DATA    *worldGetRoom(WORLD_DATA *world, const char *key);
 ROOM_DATA *worldRemoveRoom(WORLD_DATA *world, const char *key);
diff -ruN versions/nakedmudv3.6/src/zone.c src/zone.c
--- versions/nakedmudv3.6/src/zone.c	2008-05-31 00:17:59.000000000 -0400
+++ src/zone.c	2008-12-03 16:51:13.000000000 -0500
@@ -25,24 +25,67 @@
 // zone type data
 //*****************************************************************************
 typedef struct {
+  /*
   void      *(* read_func)(STORAGE_SET *);
   STORAGE_SET     *(* store_func)(void *);
   void            (* delete_func)(void *);
   void (* key_func)(void *, const char *);
-  HASHTABLE                  *key_map;
+  */
+  void    *read_func;
+  void   *store_func;
+  void  *delete_func;
+  void     *key_func;
+  bool     forgetful;
+  HASHTABLE *key_map;
+  char         *type;
 } ZONE_TYPE_DATA;
 
-ZONE_TYPE_DATA *newZoneType(void *reader, void *storer, void *deleter,
-			    void *keysetter) {
+ZONE_TYPE_DATA *newZoneType(const char *type, void *reader, void *storer, 
+			    void *deleter, void *keysetter, bool forgetful) {
   ZONE_TYPE_DATA *data = malloc(sizeof(ZONE_TYPE_DATA));
   data->read_func      = reader;
   data->store_func     = storer;
   data->delete_func    = deleter;
   data->key_func       = keysetter;
+  data->forgetful      = forgetful;
   data->key_map        = newHashtable();
+  data->type           = strdupsafe(type);
   return data;
 }
 
+void *do_zone_read(ZONE_TYPE_DATA *tdata, STORAGE_SET *set) {
+  if(tdata->forgetful) {
+    void *(* read_func)(const char *, STORAGE_SET *) = tdata->read_func;
+    return read_func(tdata->type, set);
+  }
+  else {
+    void *(* read_func)(STORAGE_SET *) = tdata->read_func;
+    return read_func(set);
+  }
+}
+
+void do_zone_setkey(ZONE_TYPE_DATA *tdata, void *data, const char *key) {
+  if(tdata->forgetful) {
+    void (* key_func)(const char *, void *, const char *) = tdata->key_func;
+    key_func(tdata->type, data, key);
+  }
+  else {
+    void (* key_func)(void *, const char *) = tdata->key_func;
+    key_func(data, key);
+  }
+}
+
+STORAGE_SET *do_zone_store(ZONE_TYPE_DATA *tdata, void *data) {
+  if(tdata->forgetful) {
+    STORAGE_SET *(* store_func)(const char *, void *) = tdata->store_func;
+    return store_func(tdata->type, data);
+  }
+  else {
+    STORAGE_SET *(* store_func)(void *) = tdata->store_func;
+    return store_func(data);
+  }
+}
+
 
 
 //*****************************************************************************
@@ -304,9 +347,9 @@
 	    type, key);
     STORAGE_SET *set = storage_read(buf);
     if(set != NULL) {
-      data = tdata->read_func(set);
+      data = do_zone_read(tdata, set);
       hashPut(tdata->key_map, key, data);
-      tdata->key_func(data, get_fullkey(key, zone->key));
+      do_zone_setkey(tdata, data, get_fullkey(key, zone->key));
       storage_close(set);
     }
     return data;
@@ -330,7 +373,7 @@
   void *data = zoneGetType(zone, type, key);
   if(data != NULL) {
     ZONE_TYPE_DATA *tdata = hashGet(zone->type_table, type);
-    STORAGE_SET      *set = tdata->store_func(data);
+    STORAGE_SET      *set = do_zone_store(tdata, data);
     if(set != NULL) {
       char buf[MAX_BUFFER];
       sprintf(buf,"%s/%s/%s",worldGetZonePath(zone->world,zone->key),type,key);
@@ -352,7 +395,7 @@
     // then remove it from the key map
     void *data = hashRemove(tdata->key_map, key);
     if(data != NULL)
-      tdata->key_func(data, "");
+      do_zone_setkey(tdata, data, "");
     return data;
   }
 }
@@ -362,15 +405,26 @@
   ZONE_TYPE_DATA *tdata = hashGet(zone->type_table, type);
   if(tdata != NULL) {
     hashPut(tdata->key_map, key, data);
-    tdata->key_func(data, get_fullkey(key, zone->key));
+    do_zone_setkey(tdata, data, get_fullkey(key, zone->key));
   }
 }
 
 void zoneAddType(ZONE_DATA *zone, const char *type, void *reader, 
 		 void *storer, void *deleter, void *typesetter) {
   if(!hashIn(zone->type_table, type)) {
-    hashPut(zone->type_table, type, newZoneType(reader, storer, deleter, 
-						typesetter));
+    hashPut(zone->type_table, type, newZoneType(type, reader, storer, deleter, 
+						typesetter, FALSE));
+    char buf[MAX_BUFFER];
+    sprintf(buf, "%s/%s", worldGetZonePath(zone->world, zone->key), type);
+    mkdir(buf, S_IRWXU | S_IRWXG);
+  }
+}
+
+void zoneAddForgetfulType(ZONE_DATA *zone, const char *type, void *reader, 
+			  void *storer, void *deleter, void *typesetter) {
+  if(!hashIn(zone->type_table, type)) {
+    hashPut(zone->type_table, type, newZoneType(type, reader, storer, deleter, 
+						typesetter, TRUE));
     char buf[MAX_BUFFER];
     sprintf(buf, "%s/%s", worldGetZonePath(zone->world, zone->key), type);
     mkdir(buf, S_IRWXU | S_IRWXG);
diff -ruN versions/nakedmudv3.6/src/zone.h src/zone.h
--- versions/nakedmudv3.6/src/zone.h	2008-05-31 00:17:59.000000000 -0400
+++ src/zone.h	2008-12-03 16:29:13.000000000 -0500
@@ -86,4 +86,13 @@
 		       void *storer, void *deleter, void *keysetter);
 LIST  *zoneGetTypeKeys(ZONE_DATA *zone, const char *type);
 
+//
+// some types can 'forget' what they are. This is a fudge so Python can add
+// types to zones, and we can do a lookup on the functions that need to
+// be called, without having to explicitly deal with Python in zone.c.
+// Forgetful functions are exactly the same as normal functions, except they
+// take an additional initial argument, which is a const string of their type
+void zoneAddForgetfulType(ZONE_DATA *zone, const char *type, void *reader,
+			  void *storer, void *deleter, void *keysetter);
+
 #endif // __ZONE_H
diff -ruN versions/nakedmudv3.6/lib/pymodules/char_gen.py lib/pymodules/char_gen.py
--- versions/nakedmudv3.6/lib/pymodules/char_gen.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/char_gen.py	2008-11-05 14:00:21.000000000 -0500
@@ -48,7 +48,7 @@
     if not mud.is_race(arg, True):
         sock.send("Invalid race selection, try again.")
     else:
-        sock.ch.race = arg
+        sock.ch.race = arg.lower()
         sock.pop_ih()
 
 def cg_finish_handler(sock, arg):
diff -ruN versions/nakedmudv3.6/lib/pymodules/cmd_admin.py lib/pymodules/cmd_admin.py
--- versions/nakedmudv3.6/lib/pymodules/cmd_admin.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/cmd_admin.py	2008-11-17 23:37:22.000000000 -0500
@@ -20,7 +20,7 @@
     ch.send("You must spell out shutdown completely!")
 
 def cmd_copyover(ch, cmd, arg):
-    '''Restarts the mud, and keep all sockets connected.'''
+    '''Restarts the mud, and keep all sockets connected.''' 
     mudsys.do_copyover()
 
 def cmd_copyover_net(ch, cmd, arg):
@@ -49,7 +49,8 @@
     '''Usage: pulserate <pulses>
     
       Changes the number of pulses the mud experiences each second. The mud
-      makes one loop through the main game handler each pulse.'''
+      makes one loop through the main game handler each pulse.
+      '''
     if arg == '':
         ch.send("The mud currently has "+mudsys.sys_getval("pulses_per_second")+
                 "pulses per second.")
diff -ruN versions/nakedmudv3.6/lib/pymodules/cmd_manip.py lib/pymodules/cmd_manip.py
--- versions/nakedmudv3.6/lib/pymodules/cmd_manip.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/cmd_manip.py	2008-05-31 04:25:57.000000000 -0400
@@ -193,7 +193,9 @@
     elif ch.equip(obj, where):
         message(ch, None, obj, None, True, "to_char", "You wear $o.")
         message(ch, None, obj, None, True, "to_room", "$n wears $o.")
-        # equip hooks are done in the C code
+
+        # run our wear hook
+        hooks.run("wear", hooks.build_info("ch obj", (ch, obj)))
     else:
         message(ch, None, obj, None, True, "to_char", "You could not equip $o.")
 
diff -ruN versions/nakedmudv3.6/lib/pymodules/routine.py lib/pymodules/routine.py
--- versions/nakedmudv3.6/lib/pymodules/routine.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/routine.py	2008-12-01 03:33:48.000000000 -0500
@@ -199,4 +199,9 @@
 add_cmd("routine", None, cmd_routine, "admin", False)
 
 # misc initialization
-mud.set_routine = set_routine
+# mud.set_routine = set_routine
+#
+# now use:    ch.set_routine(routine)
+# instead of: mud.set_routine(ch, routine)
+#
+mudsys.add_char_method("set_routine", set_routine)
diff -ruN versions/nakedmudv3.6/lib/pymodules/utils.py lib/pymodules/utils.py
--- versions/nakedmudv3.6/lib/pymodules/utils.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/utils.py	2008-12-01 20:13:52.000000000 -0500
@@ -112,3 +112,22 @@
             else:
                 ch.send(m_func(thing) % count)
         else: pass
+
+def olc_display_table(sock, list, num_cols, disp = lambda x: x):
+    '''used by OLC functions to display a list of options in a table form.
+       Also displays each option\'s position number and colorizes everything.'''
+    print_room = (80 - 10*num_cols)/num_cols;
+    fmt        = "  {c%%2d{y) {g%%-%ds%%s" % print_room
+    i          = 0
+
+    # display each cell
+    for item in list:
+        endtag = "   "
+        if i % num_cols == (num_cols - 1):
+            endtag = "\r\n"
+        sock.send_raw(fmt % (i, disp(item), endtag))
+        i += 1
+
+    # do we need to end this with a newline?
+    if i % num_cols != 0:
+        sock.send_raw("\r\n")
